"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const cli_ux_1 = require("cli-ux");
const base_1 = require("../base");
const g = global;
const bin = g.config ? g.config.bin : 'heroku';
class PluginsUninstall extends base_1.default {
    run() {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            const [plugin] = this.argv;
            cli_ux_1.cli.action.start(`Uninstalling ${plugin}`);
            yield this.config.plugins.uninstall(plugin);
        });
    }
}
PluginsUninstall.topic = 'plugins';
PluginsUninstall.command = 'uninstall';
PluginsUninstall.args = [{ name: 'plugin', description: 'plugin name to uninstall', required: true }];
PluginsUninstall.aliases = ['plugins:unlink'];
PluginsUninstall.description = 'uninstalls or unlinks a plugin';
PluginsUninstall.help = `Example:
    $ ${bin} plugins:uninstall heroku-accounts
`;
exports.default = PluginsUninstall;
