"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const cli_ux_1 = require("cli-ux");
const command_1 = require("../command");
const base_1 = require("./base");
class default_1 extends base_1.default {
    run() {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            this.cm = new command_1.CommandManager(this.config);
            const id = this.argv[0];
            const command = yield this.cm.findCommand(id, true);
            const plugin = command.plugin;
            cli_ux_1.default.styledHeader(`Plugin ${plugin.name}`);
            cli_ux_1.default.styledObject(plugin, ['version', 'type', 'path']);
        });
    }
}
default_1.topic = 'which';
default_1.description = 'show which plugin a command is from';
default_1.args = [{ name: 'command', required: true }];
exports.default = default_1;
