"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const path = require("path");
const plugin_1 = require("./plugin");
class Builtin extends plugin_1.Plugin {
    constructor(config) {
        const root = path.join(__dirname, '../..');
        const pjson = require(path.join(root, 'package.json'));
        super({ config, type: 'builtin', root, pjson });
    }
    get commandsDir() {
        return path.join(__dirname, '..', 'commands');
    }
    commandIDsFromDir() {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            const ids = ['commands', 'help', 'update', 'version', 'which'];
            if (!this.config.userPluginsEnabled)
                return ids;
            return [...ids, 'plugins', 'plugins:install', 'plugins:link', 'plugins:uninstall', 'plugins:update'];
        });
    }
}
exports.Builtin = Builtin;
