/// <reference types="chalk" />
import ansiStyles = require('ansi-styles');
import chalk = require('chalk');
import * as moment from 'moment';
import fs = require('fs-extra');
import { IBaseOptions } from './base';
import { SpinnerAction } from './action/spinner';
import { SimpleAction } from './action/simple';
import { Errors } from './errors';
import { Prompt } from './prompt';
import { StreamOutput } from './stream';
import { TableOptions } from './table';
export declare const deps: {
    readonly ansiEscapes: any;
    readonly ansiStyles: typeof ansiStyles;
    readonly chalk: typeof chalk;
    readonly fs: typeof fs;
    readonly linewrap: any;
    readonly moment: typeof moment;
    readonly passwordPrompt: any;
    readonly stripAnsi: (str: string) => string;
    readonly supportsColor: any;
    readonly shouldDisplaySpinner: (options: IBaseOptions) => boolean;
    readonly SpinnerAction: typeof SpinnerAction;
    readonly SimpleAction: typeof SimpleAction;
    readonly Errors: typeof Errors;
    readonly Prompt: typeof Prompt;
    readonly StreamOutput: typeof StreamOutput;
    readonly table: (stream: StreamOutput, data: any[], inputOptions?: Partial<TableOptions>) => void;
};
