"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const screen_1 = require("./screen");
const ts_lodash_1 = require("ts-lodash");
function linewrap(length, s) {
    const lw = require('@heroku/linewrap');
    return lw(length, screen_1.default.stdtermwidth, {
        skipScheme: 'ansi-color',
    })(s).trim();
}
function renderList(items) {
    if (items.length === 0) {
        return '';
    }
    const maxLength = ts_lodash_1.default.maxBy(items, '[0].length')[0].length;
    const lines = items.map(i => {
        let left = i[0];
        let right = i[1];
        if (!right) {
            return left;
        }
        left = `${ts_lodash_1.default.padEnd(left, maxLength)}`;
        right = linewrap(maxLength + 2, right);
        return `${left}  ${right}`;
    });
    return lines.join('\n');
}
exports.renderList = renderList;
