"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const debug_1 = require("./debug");
const validate_1 = require("./validate");
function isActive(pid) {
    return Promise.resolve(isActiveSync(pid));
}
exports.isActive = isActive;
function isActiveSync(pid) {
    if (!validate_1.default(pid))
        return false;
    try {
        debug_1.default('isActive', pid);
        const result = process.kill(pid, 0);
        debug_1.default('isActive', result);
        return !!result;
    }
    catch (e) {
        debug_1.default('isActive', e);
        if (e.code === 'EPERM')
            return true;
        if (e.code === 'ESRCH')
            return false;
        throw e;
    }
}
exports.isActiveSync = isActiveSync;
